diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/functions.php ./wordpress-3.3/wp-includes/functions.php
*** ./wordpress-3.2.1/wp-includes/functions.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/functions.php	2011-11-23 11:29:49.000000000 -0600
***************
*** 20,26 ****
   * @param string $dateformatstring Either 'G', 'U', or php date format.
   * @param string $mysqlstring Time from mysql DATETIME field.
   * @param bool $translate Optional. Default is true. Will switch format to locale.
!  * @return string Date formated by $dateformatstring or locale (if available).
   */
  function mysql2date( $dateformatstring, $mysqlstring, $translate = true ) {
  	$m = $mysqlstring;
--- 20,26 ----
   * @param string $dateformatstring Either 'G', 'U', or php date format.
   * @param string $mysqlstring Time from mysql DATETIME field.
   * @param bool $translate Optional. Default is true. Will switch format to locale.
!  * @return string Date formatted by $dateformatstring or locale (if available).
   */
  function mysql2date( $dateformatstring, $mysqlstring, $translate = true ) {
  	$m = $mysqlstring;
***************
*** 324,329 ****
--- 324,330 ----
   * 	the option value.
   *
   * @param string $option Name of option to retrieve. Expected to not be SQL-escaped.
+  * @param mixed $default Optional. Default value to return if the option does not exist.
   * @return mixed Value set for the option.
   */
  function get_option( $option, $default = false ) {
***************
*** 454,460 ****
  }
  
  /**
!  * Loads and caches certain often requested site options if is_multisite() and a peristent cache is not being used.
   *
   * @since 3.0.0
   * @package WordPress
--- 455,461 ----
  }
  
  /**
!  * Loads and caches certain often requested site options if is_multisite() and a persistent cache is not being used.
   *
   * @since 3.0.0
   * @package WordPress
***************
*** 569,579 ****
   * it will be serialized before it is inserted into the database. Remember,
   * resources can not be serialized or added as an option.
   *
!  * You can create options without values and then add values later. Does not
!  * check whether the option has already been added, but does check that you
   * aren't adding a protected WordPress option. Care should be taken to not name
!  * options the same as the ones which are protected and to not add options
!  * that were already added.
   *
   * @package WordPress
   * @subpackage Option
--- 570,579 ----
   * it will be serialized before it is inserted into the database. Remember,
   * resources can not be serialized or added as an option.
   *
!  * You can create options without values and then update the values later.
!  * Existing options will not be updated and checks are performed to ensure that you
   * aren't adding a protected WordPress option. Care should be taken to not name
!  * options the same as the ones which are protected.
   *
   * @package WordPress
   * @subpackage Option
***************
*** 586,592 ****
   * @param mixed $value Optional. Option value, can be anything. Expected to not be SQL-escaped.
   * @param mixed $deprecated Optional. Description. Not used anymore.
   * @param bool $autoload Optional. Default is enabled. Whether to load the option when WordPress starts up.
!  * @return null returns when finished.
   */
  function add_option( $option, $value = '', $deprecated = '', $autoload = 'yes' ) {
  	global $wpdb;
--- 586,592 ----
   * @param mixed $value Optional. Option value, can be anything. Expected to not be SQL-escaped.
   * @param mixed $deprecated Optional. Description. Not used anymore.
   * @param bool $autoload Optional. Default is enabled. Whether to load the option when WordPress starts up.
!  * @return bool False if option was not added and true if option was added.
   */
  function add_option( $option, $value = '', $deprecated = '', $autoload = 'yes' ) {
  	global $wpdb;
***************
*** 609,615 ****
  	$notoptions = wp_cache_get( 'notoptions', 'options' );
  	if ( !is_array( $notoptions ) || !isset( $notoptions[$option] ) )
  		if ( false !== get_option( $option ) )
! 			return;
  
  	$_value = $value;
  	$value = maybe_serialize( $value );
--- 609,615 ----
  	$notoptions = wp_cache_get( 'notoptions', 'options' );
  	if ( !is_array( $notoptions ) || !isset( $notoptions[$option] ) )
  		if ( false !== get_option( $option ) )
! 			return false;
  
  	$_value = $value;
  	$value = maybe_serialize( $value );
***************
*** 686,692 ****
  }
  
  /**
!  * Delete a transient
   *
   * @since 2.8.0
   * @package WordPress
--- 686,692 ----
  }
  
  /**
!  * Delete a transient.
   *
   * @since 2.8.0
   * @package WordPress
***************
*** 719,725 ****
  }
  
  /**
!  * Get the value of a transient
   *
   * If the transient does not exist or does not have a value, then the return value
   * will be false.
--- 719,725 ----
  }
  
  /**
!  * Get the value of a transient.
   *
   * If the transient does not exist or does not have a value, then the return value
   * will be false.
***************
*** 768,774 ****
  }
  
  /**
!  * Set/update the value of a transient
   *
   * You do not need to serialize values. If the value needs to be serialized, then
   * it will be serialized before it is set.
--- 768,774 ----
  }
  
  /**
!  * Set/update the value of a transient.
   *
   * You do not need to serialize values. If the value needs to be serialized, then
   * it will be serialized before it is set.
***************
*** 1037,1042 ****
--- 1037,1044 ----
  	if ( is_array( $data ) || is_object( $data ) )
  		return serialize( $data );
  
+ 	// Double serialization is required for backward compatibility.
+ 	// See http://core.trac.wordpress.org/ticket/12930
  	if ( is_serialized( $data ) )
  		return serialize( $data );
  
***************
*** 1417,1424 ****
   * using this function. You can also retrieve the full URL with query data.
   *
   * Adding a single key & value or an associative array. Setting a key value to
!  * emptystring removes the key. Omitting oldquery_or_uri uses the $_SERVER
!  * value.
   *
   * @since 1.5.0
   *
--- 1419,1427 ----
   * using this function. You can also retrieve the full URL with query data.
   *
   * Adding a single key & value or an associative array. Setting a key value to
!  * an empty string removes the key. Omitting oldquery_or_uri uses the $_SERVER
!  * value. Additional values provided are expected to be encoded appropriately
!  * with urlencode() or rawurlencode().
   *
   * @since 1.5.0
   *
***************
*** 1794,1800 ****
  }
  
  /**
!  * Load the RSS 1.0 Feed Template
   *
   * @since 2.1.0
   */
--- 1797,1803 ----
  }
  
  /**
!  * Load the RSS 1.0 Feed Template.
   *
   * @since 2.1.0
   */
***************
*** 1831,1857 ****
  }
  
  /**
!  * Display the robot.txt file content.
   *
   * The echo content should be with usage of the permalinks or for creating the
!  * robot.txt file.
   *
   * @since 2.1.0
!  * @uses do_action() Calls 'do_robotstxt' hook for displaying robot.txt rules.
   */
  function do_robots() {
  	header( 'Content-Type: text/plain; charset=utf-8' );
  
  	do_action( 'do_robotstxt' );
  
! 	$output = '';
  	$public = get_option( 'blog_public' );
! 	if ( '0' ==  $public ) {
! 		$output .= "User-agent: *\n";
  		$output .= "Disallow: /\n";
  	} else {
! 		$output .= "User-agent: *\n";
! 		$output .= "Disallow:\n";
  	}
  
  	echo apply_filters('robots_txt', $output, $public);
--- 1834,1861 ----
  }
  
  /**
!  * Display the robots.txt file content.
   *
   * The echo content should be with usage of the permalinks or for creating the
!  * robots.txt file.
   *
   * @since 2.1.0
!  * @uses do_action() Calls 'do_robotstxt' hook for displaying robots.txt rules.
   */
  function do_robots() {
  	header( 'Content-Type: text/plain; charset=utf-8' );
  
  	do_action( 'do_robotstxt' );
  
! 	$output = "User-agent: *\n";
  	$public = get_option( 'blog_public' );
! 	if ( '0' == $public ) {
  		$output .= "Disallow: /\n";
  	} else {
! 		$site_url = parse_url( site_url() );
! 		$path = ( !empty( $site_url['path'] ) ) ? $site_url['path'] : '';
! 		$output .= "Disallow: $path/wp-admin/\n";
! 		$output .= "Disallow: $path/wp-includes/\n";
  	}
  
  	echo apply_filters('robots_txt', $output, $public);
***************
*** 1895,1926 ****
  	if ( $installed )
  		return true;
  
  	$suppress = $wpdb->suppress_errors();
- 	$tables = $wpdb->get_col('SHOW TABLES');
- 	$wpdb->suppress_errors( $suppress );
  
- 	$wp_tables = $wpdb->tables();
  	// Loop over the WP tables.  If none exist, then scratch install is allowed.
  	// If one or more exist, suggest table repair since we got here because the options
  	// table could not be accessed.
  	foreach ( $wp_tables as $table ) {
! 		// If one of the WP tables exist, then we are in an insane state.
! 		if ( in_array( $table, $tables ) ) {
! 			// The existence of custom user tables shouldn't suggest an insane state or prevent a clean install.
! 			if ( defined( 'CUSTOM_USER_TABLE' ) && CUSTOM_USER_TABLE == $table )
! 				continue;
! 			if ( defined( 'CUSTOM_USER_META_TABLE' ) && CUSTOM_USER_META_TABLE == $table )
! 				continue;
  
! 			// If visiting repair.php, return true and let it take over.
! 			if ( defined('WP_REPAIRING') )
! 				return true;
! 			// Die with a DB error.
! 			$wpdb->error = sprintf( /*WP_I18N_NO_TABLES*/'One or more database tables are unavailable.  The database may need to be <a href="%s">repaired</a>.'/*/WP_I18N_NO_TABLES*/, 'maint/repair.php?referrer=is_blog_installed' );
! 			dead_db();
! 		}
  	}
  
  	wp_cache_set( 'is_blog_installed', false );
  
  	return false;
--- 1899,1933 ----
  	if ( $installed )
  		return true;
  
+ 	// If visiting repair.php, return true and let it take over.
+ 	if ( defined( 'WP_REPAIRING' ) )
+ 		return true;
+ 
  	$suppress = $wpdb->suppress_errors();
  
  	// Loop over the WP tables.  If none exist, then scratch install is allowed.
  	// If one or more exist, suggest table repair since we got here because the options
  	// table could not be accessed.
+ 	$wp_tables = $wpdb->tables();
  	foreach ( $wp_tables as $table ) {
! 		// The existence of custom user tables shouldn't suggest an insane state or prevent a clean install.
! 		if ( defined( 'CUSTOM_USER_TABLE' ) && CUSTOM_USER_TABLE == $table )
! 			continue;
! 		if ( defined( 'CUSTOM_USER_META_TABLE' ) && CUSTOM_USER_META_TABLE == $table )
! 			continue;
  
! 		if ( ! $wpdb->get_results( "DESCRIBE $table;" ) )
! 			continue;
! 
! 		// One or more tables exist. We are insane.
! 
! 		// Die with a DB error.
! 		$wpdb->error = sprintf( /*WP_I18N_NO_TABLES*/'One or more database tables are unavailable.  The database may need to be <a href="%s">repaired</a>.'/*/WP_I18N_NO_TABLES*/, 'maint/repair.php?referrer=is_blog_installed' );
! 		dead_db();
  	}
  
+ 	$wpdb->suppress_errors( $suppress );
+ 
  	wp_cache_set( 'is_blog_installed', false );
  
  	return false;
***************
*** 2030,2036 ****
  }
  
  /**
!  * Retrieve referer from '_wp_http_referer', HTTP referer, or current page respectively.
   *
   * @package WordPress
   * @subpackage Security
--- 2037,2044 ----
  }
  
  /**
!  * Retrieve referer from '_wp_http_referer' or HTTP referer. If it's the same
!  * as the current request URL, will return false.
   *
   * @package WordPress
   * @subpackage Security
***************
*** 2039,2051 ****
   * @return string|bool False on failure. Referer URL on success.
   */
  function wp_get_referer() {
! 	$ref = '';
  	if ( ! empty( $_REQUEST['_wp_http_referer'] ) )
  		$ref = $_REQUEST['_wp_http_referer'];
  	else if ( ! empty( $_SERVER['HTTP_REFERER'] ) )
  		$ref = $_SERVER['HTTP_REFERER'];
  
! 	if ( $ref !== $_SERVER['REQUEST_URI'] )
  		return $ref;
  	return false;
  }
--- 2047,2059 ----
   * @return string|bool False on failure. Referer URL on success.
   */
  function wp_get_referer() {
! 	$ref = false;
  	if ( ! empty( $_REQUEST['_wp_http_referer'] ) )
  		$ref = $_REQUEST['_wp_http_referer'];
  	else if ( ! empty( $_SERVER['HTTP_REFERER'] ) )
  		$ref = $_SERVER['HTTP_REFERER'];
  
! 	if ( $ref && $ref !== $_SERVER['REQUEST_URI'] )
  		return $ref;
  	return false;
  }
***************
*** 2125,2131 ****
  		return true;
  
  	// a path starting with / or \ is absolute; anything else is relative
! 	return (bool) preg_match('#^[/\\\\]#', $path);
  }
  
  /**
--- 2133,2139 ----
  		return true;
  
  	// a path starting with / or \ is absolute; anything else is relative
! 	return ( $path[0] == '/' || $path[0] == '\\' );
  }
  
  /**
***************
*** 2432,2438 ****
  		'spreadsheet' => array( 'numbers',     'ods',  'xls',  'xlsx', 'xlsb',  'xlsm' ),
  		'interactive' => array( 'key', 'ppt',  'pptx', 'pptm', 'odp',  'swf' ),
  		'text'        => array( 'asc', 'csv',  'tsv',  'txt' ),
! 		'archive'     => array( 'bz2', 'cab',  'dmg',  'gz',   'rar',  'sea',   'sit', 'sqx', 'tar', 'tgz',  'zip' ),
  		'code'        => array( 'css', 'htm',  'html', 'php',  'js' ),
  	));
  	foreach ( $ext2type as $type => $exts )
--- 2440,2446 ----
  		'spreadsheet' => array( 'numbers',     'ods',  'xls',  'xlsx', 'xlsb',  'xlsm' ),
  		'interactive' => array( 'key', 'ppt',  'pptx', 'pptm', 'odp',  'swf' ),
  		'text'        => array( 'asc', 'csv',  'tsv',  'txt' ),
! 		'archive'     => array( 'bz2', 'cab',  'dmg',  'gz',   'rar',  'sea',   'sit', 'sqx', 'tar', 'tgz',  'zip', '7z' ),
  		'code'        => array( 'css', 'htm',  'html', 'php',  'js' ),
  	));
  	foreach ( $ext2type as $type => $exts )
***************
*** 2598,2603 ****
--- 2606,2613 ----
  		'tar' => 'application/x-tar',
  		'zip' => 'application/zip',
  		'gz|gzip' => 'application/x-gzip',
+ 		'rar' => 'application/rar',
+ 		'7z' => 'application/x-7z-compressed',
  		'exe' => 'application/x-msdownload',
  		// openoffice formats
  		'odt' => 'application/vnd.oasis.opendocument.text',
***************
*** 2744,2756 ****
   * HTML will be displayed to the user. It is recommended to use this function
   * only, when the execution should not continue any further. It is not
   * recommended to call this function very often and try to handle as many errors
!  * as possible siliently.
   *
   * @since 2.0.4
   *
   * @param string $message Error message.
   * @param string $title Error title.
!  * @param string|array $args Optional arguements to control behaviour.
   */
  function wp_die( $message, $title = '', $args = array() ) {
  	if ( defined( 'DOING_AJAX' ) && DOING_AJAX )
--- 2754,2766 ----
   * HTML will be displayed to the user. It is recommended to use this function
   * only, when the execution should not continue any further. It is not
   * recommended to call this function very often and try to handle as many errors
!  * as possible silently.
   *
   * @since 2.0.4
   *
   * @param string $message Error message.
   * @param string $title Error title.
!  * @param string|array $args Optional arguments to control behavior.
   */
  function wp_die( $message, $title = '', $args = array() ) {
  	if ( defined( 'DOING_AJAX' ) && DOING_AJAX )
***************
*** 2776,2782 ****
   *
   * @param string $message Error message.
   * @param string $title Error title.
!  * @param string|array $args Optional arguements to control behaviour.
   */
  function _default_wp_die_handler( $message, $title = '', $args = array() ) {
  	$defaults = array( 'response' => 500 );
--- 2786,2792 ----
   *
   * @param string $message Error message.
   * @param string $title Error title.
!  * @param string|array $args Optional arguments to control behavior.
   */
  function _default_wp_die_handler( $message, $title = '', $args = array() ) {
  	$defaults = array( 'response' => 500 );
***************
*** 2808,2855 ****
  
  	if ( isset( $r['back_link'] ) && $r['back_link'] ) {
  		$back_text = $have_gettext? __('&laquo; Back') : '&laquo; Back';
! 		$message .= "\n<p><a href='javascript:history.back()'>$back_text</p>";
  	}
  
- 	if ( defined( 'WP_SITEURL' ) && '' != WP_SITEURL )
- 		$admin_dir = WP_SITEURL . '/wp-admin/';
- 	elseif ( function_exists( 'get_bloginfo' ) && '' != get_bloginfo( 'wpurl' ) )
- 		$admin_dir = get_bloginfo( 'wpurl' ) . '/wp-admin/';
- 	elseif ( strpos( $_SERVER['PHP_SELF'], 'wp-admin' ) !== false )
- 		$admin_dir = '';
- 	else
- 		$admin_dir = 'wp-admin/';
- 
  	if ( !function_exists( 'did_action' ) || !did_action( 'admin_head' ) ) :
! 	if ( !headers_sent() ) {
! 		status_header( $r['response'] );
! 		nocache_headers();
! 		header( 'Content-Type: text/html; charset=utf-8' );
! 	}
  
! 	if ( empty($title) )
! 		$title = $have_gettext ? __('WordPress &rsaquo; Error') : 'WordPress &rsaquo; Error';
! 
! 	$text_direction = 'ltr';
! 	if ( isset($r['text_direction']) && 'rtl' == $r['text_direction'] )
! 		$text_direction = 'rtl';
! 	elseif ( function_exists( 'is_rtl' ) && is_rtl() )
! 		$text_direction = 'rtl';
  ?>
! <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
! <!-- Ticket #11289, IE bug fix: always pad the error page with enough characters such that it is greater than 512 bytes, even after gzip compression abcdefghijklmnopqrstuvwxyz1234567890aabbccddeeffgghhiijjkkllmmnnooppqqrrssttuuvvwwxxyyzz11223344556677889900abacbcbdcdcededfefegfgfhghgihihjijikjkjlklkmlmlnmnmononpopoqpqprqrqsrsrtstsubcbcdcdedefefgfabcadefbghicjkldmnoepqrfstugvwxhyz1i234j567k890laabmbccnddeoeffpgghqhiirjjksklltmmnunoovppqwqrrxsstytuuzvvw0wxx1yyz2z113223434455666777889890091abc2def3ghi4jkl5mno6pqr7stu8vwx9yz11aab2bcc3dd4ee5ff6gg7hh8ii9j0jk1kl2lmm3nnoo4p5pq6qrr7ss8tt9uuvv0wwx1x2yyzz13aba4cbcb5dcdc6dedfef8egf9gfh0ghg1ihi2hji3jik4jkj5lkl6kml7mln8mnm9ono -->
  <html xmlns="http://www.w3.org/1999/xhtml" <?php if ( function_exists( 'language_attributes' ) && function_exists( 'is_rtl' ) ) language_attributes(); else echo "dir='$text_direction'"; ?>>
  <head>
  	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  	<title><?php echo $title ?></title>
! 	<link rel="stylesheet" href="<?php echo $admin_dir; ?>css/install.css" type="text/css" />
! <?php
! if ( 'rtl' == $text_direction ) : ?>
! 	<link rel="stylesheet" href="<?php echo $admin_dir; ?>css/install-rtl.css" type="text/css" />
! <?php endif; ?>
  </head>
  <body id="error-page">
! <?php endif; ?>
  	<?php echo $message; ?>
  </body>
  </html>
--- 2818,2922 ----
  
  	if ( isset( $r['back_link'] ) && $r['back_link'] ) {
  		$back_text = $have_gettext? __('&laquo; Back') : '&laquo; Back';
! 		$message .= "\n<p><a href='javascript:history.back()'>$back_text</a></p>";
  	}
  
  	if ( !function_exists( 'did_action' ) || !did_action( 'admin_head' ) ) :
! 		if ( !headers_sent() ) {
! 			status_header( $r['response'] );
! 			nocache_headers();
! 			header( 'Content-Type: text/html; charset=utf-8' );
! 		}
  
! 		if ( empty($title) )
! 			$title = $have_gettext ? __('WordPress &rsaquo; Error') : 'WordPress &rsaquo; Error';
! 
! 		$text_direction = 'ltr';
! 		if ( isset($r['text_direction']) && 'rtl' == $r['text_direction'] )
! 			$text_direction = 'rtl';
! 		elseif ( function_exists( 'is_rtl' ) && is_rtl() )
! 			$text_direction = 'rtl';
  ?>
! <!DOCTYPE html>
! <!-- Ticket #11289, IE bug fix: always pad the error page with enough characters such that it is greater than 512 bytes, even after gzip compression abcdefghijklmnopqrstuvwxyz1234567890aabbccddeeffgghhiijjkkllmmnnooppqqrrssttuuvvwwxxyyzz11223344556677889900abacbcbdcdcededfefegfgfhghgihihjijikjkjlklkmlmlnmnmononpopoqpqprqrqsrsrtstsubcbcdcdedefefgfabcadefbghicjkldmnoepqrfstugvwxhyz1i234j567k890laabmbccnddeoeffpgghqhiirjjksklltmmnunoovppqwqrrxsstytuuzvvw0wxx1yyz2z113223434455666777889890091abc2def3ghi4jkl5mno6pqr7stu8vwx9yz11aab2bcc3dd4ee5ff6gg7hh8ii9j0jk1kl2lmm3nnoo4p5pq6qrr7ss8tt9uuvv0wwx1x2yyzz13aba4cbcb5dcdc6dedfef8egf9gfh0ghg1ihi2hji3jik4jkj5lkl6kml7mln8mnm9ono
! -->
  <html xmlns="http://www.w3.org/1999/xhtml" <?php if ( function_exists( 'language_attributes' ) && function_exists( 'is_rtl' ) ) language_attributes(); else echo "dir='$text_direction'"; ?>>
  <head>
  	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  	<title><?php echo $title ?></title>
! 	<style type="text/css">
! 		html {
! 			background: #f9f9f9;
! 		}
! 		body {
! 			background: #fff;
! 			color: #333;
! 			font-family: sans-serif;
! 			margin: 2em auto;
! 			padding: 1em 2em;
! 			-webkit-border-radius: 3px;
! 			border-radius: 3px;
! 			border: 1px solid #dfdfdf;
! 			max-width: 700px;
! 		}
! 		#error-page {
! 			margin-top: 50px;
! 		}
! 		#error-page p {
! 			font-size: 14px;
! 			line-height: 1.5;
! 			margin: 25px 0 20px;
! 		}
! 		#error-page code {
! 			font-family: Consolas, Monaco, monospace;
! 		}
! 		ul li {
! 			margin-bottom: 10px;
! 			font-size: 14px ;
! 		}
! 		a {
! 			color: #21759B;
! 			text-decoration: none;
! 		}
! 		a:hover {
! 			color: #D54E21;
! 		}
! 
! 		.button {
! 			font-family: sans-serif;
! 			text-decoration: none;
! 			font-size: 14px !important;
! 			line-height: 16px;
! 			padding: 6px 12px;
! 			cursor: pointer;
! 			border: 1px solid #bbb;
! 			color: #464646;
! 			-webkit-border-radius: 15px;
! 			border-radius: 15px;
! 			-moz-box-sizing: content-box;
! 			-webkit-box-sizing: content-box;
! 			box-sizing: content-box;
! 		}
! 
! 		.button:hover {
! 			color: #000;
! 			border-color: #666;
! 		}
! 
! 		.button {
! 			background: #f2f2f2 url(<?php echo wp_guess_url(); ?>/wp-admin/images/white-grad.png) repeat-x scroll left top;
! 		}
! 
! 		.button:active {
! 			background: #eee url(<?php echo wp_guess_url(); ?>/wp-admin/images/white-grad-active.png) repeat-x scroll left top;
! 		}
! 		<?php if ( 'rtl' == $text_direction ) : ?>
! 		body { font-family: Tahoma, Arial; }
! 		<?php endif; ?>
! 	</style>
  </head>
  <body id="error-page">
! <?php endif; // !function_exists( 'did_action' ) || !did_action( 'admin_head' ) ?>
  	<?php echo $message; ?>
  </body>
  </html>
***************
*** 2867,2873 ****
   *
   * @param string $message Error message.
   * @param string $title Error title.
!  * @param string|array $args Optional arguements to control behaviour.
   */
  function _xmlrpc_wp_die_handler( $message, $title = '', $args = array() ) {
  	global $wp_xmlrpc_server;
--- 2934,2940 ----
   *
   * @param string $message Error message.
   * @param string $title Error title.
!  * @param string|array $args Optional arguments to control behavior.
   */
  function _xmlrpc_wp_die_handler( $message, $title = '', $args = array() ) {
  	global $wp_xmlrpc_server;
***************
*** 2896,2902 ****
  /**
   * Retrieve the WordPress home page URL.
   *
!  * If the constant named 'WP_HOME' exists, then it willl be used and returned by
   * the function. This can be used to counter the redirection on your local
   * development environment.
   *
--- 2963,2969 ----
  /**
   * Retrieve the WordPress home page URL.
   *
!  * If the constant named 'WP_HOME' exists, then it will be used and returned by
   * the function. This can be used to counter the redirection on your local
   * development environment.
   *
***************
*** 2909,2915 ****
   */
  function _config_wp_home( $url = '' ) {
  	if ( defined( 'WP_HOME' ) )
! 		return WP_HOME;
  	return $url;
  }
  
--- 2976,2982 ----
   */
  function _config_wp_home( $url = '' ) {
  	if ( defined( 'WP_HOME' ) )
! 		return untrailingslashit( WP_HOME );
  	return $url;
  }
  
***************
*** 2929,2935 ****
   */
  function _config_wp_siteurl( $url = '' ) {
  	if ( defined( 'WP_SITEURL' ) )
! 		return WP_SITEURL;
  	return $url;
  }
  
--- 2996,3002 ----
   */
  function _config_wp_siteurl( $url = '' ) {
  	if ( defined( 'WP_SITEURL' ) )
! 		return untrailingslashit( WP_SITEURL );
  	return $url;
  }
  
***************
*** 3098,3104 ****
  }
  
  /**
!  * Clean up an array, comma- or space-separated list of IDs
   *
   * @since 3.0.0
   *
--- 3165,3171 ----
  }
  
  /**
!  * Clean up an array, comma- or space-separated list of IDs.
   *
   * @since 3.0.0
   *
***************
*** 3113,3119 ****
  }
  
  /**
!  * Extract a slice of an array, given a list of keys
   *
   * @since 3.1.0
   *
--- 3180,3186 ----
  }
  
  /**
!  * Extract a slice of an array, given a list of keys.
   *
   * @since 3.1.0
   *
***************
*** 3131,3137 ****
  }
  
  /**
!  * Filters a list of objects, based on a set of key => value arguments
   *
   * @since 3.0.0
   *
--- 3198,3204 ----
  }
  
  /**
!  * Filters a list of objects, based on a set of key => value arguments.
   *
   * @since 3.0.0
   *
***************
*** 3155,3161 ****
  }
  
  /**
!  * Filters a list of objects, based on a set of key => value arguments
   *
   * @since 3.1.0
   *
--- 3222,3228 ----
  }
  
  /**
!  * Filters a list of objects, based on a set of key => value arguments.
   *
   * @since 3.1.0
   *
***************
*** 3180,3188 ****
  	$filtered = array();
  
  	foreach ( $list as $key => $obj ) {
! 		$matched = count( array_intersect_assoc( (array) $obj, $args ) );
  		if ( ( 'AND' == $operator && $matched == $count )
! 		  || ( 'OR' == $operator && $matched <= $count )
  		  || ( 'NOT' == $operator && 0 == $matched ) ) {
  			$filtered[$key] = $obj;
  		}
--- 3247,3262 ----
  	$filtered = array();
  
  	foreach ( $list as $key => $obj ) {
! 		$to_match = (array) $obj;
! 
! 		$matched = 0;
! 		foreach ( $args as $m_key => $m_value ) {
! 			if ( $m_value == $to_match[ $m_key ] )
! 				$matched++;
! 		}
! 
  		if ( ( 'AND' == $operator && $matched == $count )
! 		  || ( 'OR' == $operator && $matched > 0 )
  		  || ( 'NOT' == $operator && 0 == $matched ) ) {
  			$filtered[$key] = $obj;
  		}
***************
*** 3192,3198 ****
  }
  
  /**
!  * Pluck a certain field out of each object in a list
   *
   * @since 3.1.0
   *
--- 3266,3272 ----
  }
  
  /**
!  * Pluck a certain field out of each object in a list.
   *
   * @since 3.1.0
   *
***************
*** 3202,3209 ****
   */
  function wp_list_pluck( $list, $field ) {
  	foreach ( $list as $key => $value ) {
! 		$value = (array) $value;
! 		$list[ $key ] = $value[ $field ];
  	}
  
  	return $list;
--- 3276,3285 ----
   */
  function wp_list_pluck( $list, $field ) {
  	foreach ( $list as $key => $value ) {
! 		if ( is_object( $value ) )
! 			$list[ $key ] = $value->$field;
! 		else
! 			$list[ $key ] = $value[ $field ];
  	}
  
  	return $list;
***************
*** 3285,3299 ****
  	nocache_headers();
  	header( 'Content-Type: text/html; charset=utf-8' );
  ?>
! <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
  <html xmlns="http://www.w3.org/1999/xhtml" <?php if ( function_exists( 'language_attributes' ) ) language_attributes(); ?>>
  <head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
! 	<title>Database Error</title>
  
  </head>
  <body>
! 	<h1>Error establishing a database connection</h1>
  </body>
  </html>
  <?php
--- 3361,3375 ----
  	nocache_headers();
  	header( 'Content-Type: text/html; charset=utf-8' );
  ?>
! <!DOCTYPE html>
  <html xmlns="http://www.w3.org/1999/xhtml" <?php if ( function_exists( 'language_attributes' ) ) language_attributes(); ?>>
  <head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
! 	<title><?php echo /*WP_I18N_DB_ERROR*/'Database Error'/*/WP_I18N_DB_ERROR*/; ?></title>
  
  </head>
  <body>
! 	<h1><?php echo /*WP_I18N_DB_CONNECTION_ERROR*/'Error establishing a database connection'/*/WP_I18N_DB_CONNECTION_ERROR*/; ?></h1>
  </body>
  </html>
  <?php
***************
*** 3305,3311 ****
   *
   * @since 2.5.0
   *
!  * @param mixed $maybeint Data you wish to have convered to an nonnegative integer
   * @return int An nonnegative integer
   */
  function absint( $maybeint ) {
--- 3381,3387 ----
   *
   * @since 2.5.0
   *
!  * @param mixed $maybeint Data you wish to have converted to a nonnegative integer
   * @return int An nonnegative integer
   */
  function absint( $maybeint ) {
***************
*** 3372,3378 ****
   * @param string $version The version of WordPress that deprecated the function
   * @param string $replacement Optional. The function that should have been called
   */
! function _deprecated_function( $function, $version, $replacement=null ) {
  
  	do_action( 'deprecated_function_run', $function, $replacement, $version );
  
--- 3448,3454 ----
   * @param string $version The version of WordPress that deprecated the function
   * @param string $replacement Optional. The function that should have been called
   */
! function _deprecated_function( $function, $version, $replacement = null ) {
  
  	do_action( 'deprecated_function_run', $function, $replacement, $version );
  
***************
*** 3498,3509 ****
  	// Allow plugin to filter the output error trigger
  	if ( WP_DEBUG && apply_filters( 'doing_it_wrong_trigger_error', true ) ) {
  		$version = is_null( $version ) ? '' : sprintf( __( '(This message was added in version %s.)' ), $version );
  		trigger_error( sprintf( __( '%1$s was called <strong>incorrectly</strong>. %2$s %3$s' ), $function, $message, $version ) );
  	}
  }
  
  /**
!  * Is the server running earlier than 1.5.0 version of lighttpd
   *
   * @since 2.5.0
   *
--- 3574,3586 ----
  	// Allow plugin to filter the output error trigger
  	if ( WP_DEBUG && apply_filters( 'doing_it_wrong_trigger_error', true ) ) {
  		$version = is_null( $version ) ? '' : sprintf( __( '(This message was added in version %s.)' ), $version );
+ 		$message .= ' ' . __( 'Please see <a href="http://codex.wordpress.org/Debugging_in_WordPress">Debugging in WordPress</a> for more information.' );
  		trigger_error( sprintf( __( '%1$s was called <strong>incorrectly</strong>. %2$s %3$s' ), $function, $message, $version ) );
  	}
  }
  
  /**
!  * Is the server running earlier than 1.5.0 version of lighttpd?
   *
   * @since 2.5.0
   *
***************
*** 3516,3522 ****
  }
  
  /**
!  * Does the specified module exist in the apache config?
   *
   * @since 2.5.0
   *
--- 3593,3599 ----
  }
  
  /**
!  * Does the specified module exist in the Apache config?
   *
   * @since 2.5.0
   *
***************
*** 3545,3551 ****
  }
  
  /**
!  * Check if IIS 7 supports pretty permalinks
   *
   * @since 2.8.0
   *
--- 3622,3628 ----
  }
  
  /**
!  * Check if IIS 7 supports pretty permalinks.
   *
   * @since 2.8.0
   *
***************
*** 3559,3565 ****
  		/* First we check if the DOMDocument class exists. If it does not exist,
  		 * which is the case for PHP 4.X, then we cannot easily update the xml configuration file,
  		 * hence we just bail out and tell user that pretty permalinks cannot be used.
! 		 * This is not a big issue because PHP 4.X is going to be depricated and for IIS it
  		 * is recommended to use PHP 5.X NTS.
  		 * Next we check if the URL Rewrite Module 1.1 is loaded and enabled for the web site. When
  		 * URL Rewrite 1.1 is loaded it always sets a server variable called 'IIS_UrlRewriteModule'.
--- 3636,3642 ----
  		/* First we check if the DOMDocument class exists. If it does not exist,
  		 * which is the case for PHP 4.X, then we cannot easily update the xml configuration file,
  		 * hence we just bail out and tell user that pretty permalinks cannot be used.
! 		 * This is not a big issue because PHP 4.X is going to be deprecated and for IIS it
  		 * is recommended to use PHP 5.X NTS.
  		 * Next we check if the URL Rewrite Module 1.1 is loaded and enabled for the web site. When
  		 * URL Rewrite 1.1 is loaded it always sets a server variable called 'IIS_UrlRewriteModule'.
